/* Program05_1
 *
 * A PB1 s PB0 kimenetekre kttt LED-ek villogtatsa 
 * kb 1 Hz, illetve 2 Hz frekvencival. 
 *
 * A SyTick idztt 24-bites szabadonfut visszaszmllnak
 * konfigurljuk. A szmll 23. s 22. bitjeitt folyamatosan 
 * kirjuk a GPIOB port 1., illetve  0. bitjre.
 * SysTick az alaprtelmezett 72 MHz-es rajel 8-cal leosztott
 * frekvencijval szmll, gy a 23. bitje kb. 1 Hz peridussal
 * "billeg" (72,000,000/8/2^23 = 1.07 Hz).
 * Ehhez a SyTick rajelt "External"-ra kell lltani, azaz
 * a SysTick->CTRL CLKSOURCE bitjt 0-ba kell lltani.
 *
 * Felhasznlt forrs: 
 * Mazidi et al., STM32 Arm Programming for Embedded Systems
 * http://www.microdigitaled.com/ARM/STM_ARM_books.html
 *
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"
#define ChangeBits(reg,val,mask) reg ^= ((reg^val) & mask)

int main(void) {
  /* PB0 PB1 konfigurlsa digitlis kimenetknt */
  RCC->APB2ENR |=  RCC_APB2ENR_IOPBEN; // GPIOB rajel engedlyezs
  GPIOB->CRL &= ~0x000000FF;           // CNF s Mode bitek trlse
  GPIOB->CRL |=  0x00000022;           // PB0 s PB1 pushpull kimenet, max. 2 MHz

  /* SysTick konfigurlsa szabadonfut mdba */
  SysTick->LOAD = 0xFFFFFF;            // jratlts a maximlis rtkkel
  SysTick->CTRL = 1;                   // Engedlyezs, nincs interrupt, FCY/8 rajel

  while (1) {
    /* SysTick szmlljnak 23. s 22. bitjt kimsoljuk PB1-re s PB0-ra */ 
    ChangeBits(GPIOB->ODR,(SysTick->VAL >> (23 - 1)),3UL);
  }
}



