/* Program05_2
 *
 * A PB1 kimenetre kttt LED villogtatsa 
 *
 * A SyTick idzt segtsgvel 500 ms vrakozst
 * valstunk meg. Ilyen hossz ksleltetshez 
 * az alaprtelmezett 72 MHz-es rajel 8-cal leosztott
 * frekvencijval szmolva 4,500,000-1-ig kell szmllni
 * ( count = time*FCY/8 -1 = 0.5s * 72MHz/8 -1 = 4,499,999
 * Ehhez a SyTick rajelt "External"-ra kell lltani, azaz
 * a SysTick->CTRL CLKSOURCE bitjt 0-ba kell lltani,
 * a SysTick->LOAD regsizterbe pedig 4499999-et kell rni.
 *
 * Felhasznlt forrs: 
 * Mazidi et al., STM32 Arm Programming for Embedded Systems
 * http://www.microdigitaled.com/ARM/STM_ARM_books.html
 *
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"

int main(void) {
  /* PB1 konfigurlsa digitlis kimenetknt */
  RCC->APB2ENR |=  RCC_APB2ENR_IOPBEN; // GPIOB rajel engedlyezs
  GPIOB->CRL &= ~0x000000F0;           // CNF s Mode bitek trlse
  GPIOB->CRL |=  0x00000020;           // PB1 pushpull kimenet, max. 2 MHz
  /* SysTick konfigurlsa */
  SysTick->LOAD = 4500000 - 1;         // jratltsi rtk
  SysTick->VAL = 0;                    // Szmll alaphelyzetbe
  SysTick->CTRL = 1;                   // Engedlyezs, no interrupt, FCY/8 

  while (1) {
    if (SysTick->CTRL & 0x10000) {     // Ha COUNTFLAG = 1, akkor
      GPIOB->ODR ^= 0x00000002;        // PB1 tbillentse
    }
  }
}
