/* Program05_3
 *
 * A PB1 kimenetre kttt LED villogtatsa 
 * kb 0.5 Hz frekvencival. 
 *
 * A SyTick idztvel 1 ms ksleltetsre lltjuk, s a kr
 * szervezett for ciklussal az 1 ms tbbszrseit kitev
 * ksleltetseket llthatunk el.
 * SysTick most az alaprtelmezett 72 MHz-es rajel szmllja
 * Ehhez a SyTick rajelt "System"-re kell lltani, azaz
 * a SysTick->CTRL CLKSOURCE bitjt 1-be kell lltani.
 * 1 ms ksleltetshez SystemCoreClock/1000-1 a megfelel
 * jratltsi rtk.
 *
 * Felhasznlt forrs: 
 * Mazidi et al., STM32 Arm Programming for Embedded Systems
 * http://www.microdigitaled.com/ARM/STM_ARM_books.html
 *
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"

void delayMs(int n);

int main(void) {
  /* PB1 konfigurlsa digitlis kimenetknt */
  RCC->APB2ENR |=  RCC_APB2ENR_IOPBEN;     // GPIOB rajel engedlyezs
  GPIOB->CRL &= ~0x000000F0;               // CNF s Mode bitek trlse
  GPIOB->CRL |=  0x00000020;               // PB1 pushpull kimenet, max. 2 MHz

  while (1) {
    delayMs(1000);                         // 1000 ms vrakozs
    GPIOB->ODR ^= 0x00000002;              // PB1 tbillentse
  }
}

void delayMs(int n) {
  int i;
  SysTick->LOAD = SystemCoreClock/1000-1;  // jratltsi rtk 1 ms ksleltetshez
  SysTick->VAL  = 0;                       // Szmll trlse
  SysTick->CTRL = 0x5;                     // Engedlyezs, nincs interrupt, rendszer rajel
  for(i = 0; i < n; i++) {
    while((SysTick->CTRL & 0x10000) == 0); // A COUNT jelzre vrunk
  }
  SysTick->CTRL = 0;                       // SysTick lelltsa
}




